package demo;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.tree.*;

import com.japisoft.dtdparser.*;
import com.japisoft.dtdparser.document.*;
import com.japisoft.dtdparser.node.*;

/**
 * Demonstration of XML document building from the DTD
 * </p>
 * @author (c) 2002-2003 JAPISOFT
 * @version 1.0
 */
public class Demo extends JFrame implements ActionListener {

    private JTextArea text;

    public Demo() {
	super();   
	JPanel p = new JPanel();
	p.setLayout( new BorderLayout() );
	JButton b = new JButton( "Click to Select a DTD file (samples in /dtd-samples)" );
	p.add( b, BorderLayout.NORTH );

	b.addActionListener( this );
	getContentPane().add( BorderLayout.NORTH, p );
	getContentPane().add( BorderLayout.CENTER, new JScrollPane( text = new JTextArea() ) );
	setSize( 400, 400 );
	setTitle( "Generator demo" );
    }

    public void actionPerformed( ActionEvent e ) {
	// XML Selection
	JFileChooser chooser = new JFileChooser( new File( System.getProperty( "user.dir" ) ) );

	int returnVal = chooser.showOpenDialog( this );
	if ( returnVal == JFileChooser.APPROVE_OPTION ) {
            File f = chooser.getSelectedFile();

	    try {

		Parser p = new Parser();
		p.parse( new FileInputStream( f ) );
		StringWriter sw = new StringWriter();
		XMLGenerator xg = p.getXMLGenerator();
		String root = p.getDTDElement().getFirstElementName();
		String uri = f.toString();
		xg.writeDocument( new PrintWriter( sw ), root, uri );
		text.setText( sw.toString() );

	    } catch( Throwable th ) {
		th.printStackTrace();
		JOptionPane.showMessageDialog( null, 
					       "Error", 
					       th.getMessage(), 
					       JOptionPane.ERROR_MESSAGE );
	    }
	}
    }

    public static void main( String[] a ) {
	Demo d = new Demo();
	d.setVisible( true );
    }

}

// Demo ends here
