package com.japisoft.dtdparser.swing;

import com.japisoft.dtdparser.node.*;

/**
 * Factory for Swing Node
 * 
 * @author (c) 2002 - 2003 JAPISOFT
 * @version 1.0
 */
public class SwingDTDNodeFactory extends DTDNodeFactory {

    public SwingDTDNodeFactory() {
	super();   
    }

    public DTDNode getNodeForType( int type, String arg ) {
	DTDNode node = null;

	switch( type ) {
	 case DTDNode.COMMENT :
	     node = new SwingCommentDTDNode( arg );
	     break;
	 case DTDNode.ROOT : 
	     return ( root = new SwingRootDTDNode() );
	 case DTDNode.ENTITY :
	     node = new SwingEntityDTDNode( arg, null );
	     break;
	 case DTDNode.ELEMENT :
	     node = new SwingElementDTDNode( arg );
	     break;
	 case DTDNode.ELEMENT_SET :
	     node = new SwingElementSetDTDNode();
	     break;
	 case DTDNode.ATTRIBUTE :
	     node = new SwingAttributeDTDNode( arg );
	     break;
 	 case DTDNode.ELEMENT_REF :
	     node = new SwingElementRefDTDNode( arg );
	     break;
	}
	node.setRoot( root );
	return node;
    }

}

// SwingDTDNodeFactory ends here
