package demo;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.tree.*;

import com.japisoft.dtdparser.*;
import com.japisoft.dtdparser.swing.*;
import com.japisoft.dtdparser.document.*;
import com.japisoft.dtdparser.node.*;

/**
 * Demonstration of parsing result with a Jtree 
 * </p>
 * @author (c) 2002-2003 JAPISOFT
 * @version 1.0
 */
public class Demo extends JFrame implements ActionListener {

    private JTree tree;

    public Demo() {
	super();   
	JPanel p = new JPanel();
	p.setLayout( new BorderLayout() );
	JButton b = new JButton( "Click to Select a DTD file (samples in /dtd-samples)" );
	p.add( b, BorderLayout.NORTH );

	b.addActionListener( this );
	getContentPane().add( BorderLayout.NORTH, p );
	getContentPane().add( BorderLayout.CENTER, new JScrollPane( tree = new JTree() ) );
	setSize( 400, 400 );
	setTitle( "Swing demo" );
    }

    public void actionPerformed( ActionEvent e ) {
	// XML Selection
	JFileChooser chooser = new JFileChooser( new File( System.getProperty( "user.dir" ) ) );

	int returnVal = chooser.showOpenDialog( this );
	if ( returnVal == JFileChooser.APPROVE_OPTION ) {
            File f = chooser.getSelectedFile();

	    try {

		Parser p = new Parser();
		p.getDTDDocumentBuilder().setNodeFactory( new SwingDTDNodeFactory() );
		p.parse( new FileInputStream( f ) );

		System.out.println( ">" + p.getDTDElement() );
		tree.setModel( new DefaultTreeModel( (TreeNode)p.getDTDElement() ) );

	    } catch( Throwable th ) {
		th.printStackTrace();
		JOptionPane.showMessageDialog( null, 
					       "Error", 
					       th.getMessage(), 
					       JOptionPane.ERROR_MESSAGE );
	    }
	}
    }

    public static void main( String[] a ) {
	Demo d = new Demo();
	d.setVisible( true );
    }

}

// Demo ends here
