package demo;

import java.io.*;
import java.util.*;
import com.japisoft.dtdparser.*;

/**
 * Sample of validating processing. This is
 * a facility for testing cases.
 *
 * @author (c) 2002-2003 JAPISOFT
 * @version 1.0
 * @since 1.0
 */
public class Demo {

    public static void main( String[] args ) throws Throwable {
	if ( args.length != 2 ) {
	    System.err.println( "Invalid argument : need a dtd file and a list of case" );
	    System.exit( 1 );
	}

	// Parse it

	Parser p = new Parser();
	p.parse( new FileInputStream( args[ 0 ] ) );
	XMLValidator v = p.getXMLValidator();

	// List of case

	BufferedReader br = new BufferedReader( 
					       new FileReader( args[ 1 ] ) );
	String line;
	while ( ( line = br.readLine() ) != null ) {
	    if ( line.startsWith( "A" ) ) { // Attribute test
		StringTokenizer st = new StringTokenizer( line );
		st.nextToken();
		System.out.println( "Test:" + line + ":" +
				    v.isAttributeValid( st.nextToken(), st.nextToken() ) );

	    } else
		if ( line.startsWith( "E" ) ) { // Element test
		    StringTokenizer st = new StringTokenizer( line );
		    st.nextToken();
		    System.out.println( "Test:" + line + ":" +
					v.isNodeValid( t( st.nextToken() ), t( st.nextToken() ), t( st.nextToken() ), Integer.parseInt( st.nextToken() ) ) );
		}
	}

	br.close();

    }

    public static String t( String t ) {
	if ( "[]".equals( t ) )
	    return null;
	return t;
    }

}
